# 6/4/99 g haerr
# Micro-Win / Nano-X Makefile for Linux and ELKS
#
# Micro-Win and Nano-X can be configured to run on linux or elks.
# On linux, either the included bogl libraries for linux 2.x framebuffers
# or the svgalib for all VGA hardware can be used.
# In addition, a gpm or direct serial mouse driver can be configured.
#
# Three demo programs can be compiled, see DEMO=
#
# For MSDOS makes, see mcnano.mak
#

# build target: linux or elks
LINUX=1
xELKS=1

# if linux, vgalib or bogl screen library, gpm or serial mouse driver
BOGL=1
xVGALIB=1
GPMMOUSE=1
xSERMOUSE=1

# comment the following line to build client/server version
GS_NONETWORK=1

# bogl library location
LIBBOGL=drivers/bogl/libbogl.a
xLIBBOGL=/home/greg/net/bogl/libbogl.a

# vgalib library location
LIBVGA=-lvga

ifdef LINUX
CC = gcc
CFLAGS = -DLINUX=1 -DUNIX=1 -Wall -g
xCFLAGS = -DLINUX=1 -DUNIX=1 -Wall -O3
endif

ifdef ELKS
CC = bcc
INC = -I/home/greg/net/elks/include
CFLAGS = $(INC) -DELKS=1 -DUNIX=1 -0 -Dconst= -Dvolatile=
endif

LDFLAGS =
LIBS =
PREFIX = /usr
LIBDIR = $(PREFIX)/lib
BINDIR = $(PREFIX)/bin
INCDIR = $(PREFIX)/include

ALL = nano-X
xSERVFILES = winmain.o winfunc.o winutil.o winevent.o list.o\
	winuser.o wingdi.o
SERVFILES = srvmain.o srvfunc.o srvutil.o srvevent.o
SERVFILES += devdraw.o devmouse.o devkbd.o devclip.o
CLNTFILES = client.o
NETFILES=srvnet.o

# demo programs
DEMO=../examples/landmine.o stubs.o
xDEMO=../examples/world.o stubs.o
xDEMO=../examples/demo.o stubs.o
xDEMO=../examples/demo2.o stubs.o
xDEMO=../examples/info.o stubs.o
xDEMO=test.o

ifdef LINUX

# screen library
ifdef BOGL
CFLAGS += -DBOGL=1
SERVFILES += devpal8.o drivers/scr_bogl.o $(LIBBOGL)
endif
ifdef VGALIB
SERVFILES += devpal8.o drivers/scr_svga.o
LIBS += $(LIBVGA)
endif

# mouse driver
ifdef GPMMOUSE
SERVFILES += drivers/mou_gpm.o
endif
ifdef SERMOUSE
SERVFILES += drivers/mou_ser.o
endif

SERVFILES += drivers/kbd_tty.o
SERVFILES += drivers/fonts/libfonts.a
endif

ifdef ELKS
SERVFILES += devpal4.o drivers/scr_bios.o drivers/vgaplan4.o drivers/elksutil.o
SERVFILES += drivers/mou_ser.o
SERVFILES += drivers/kbd_tty.o
endif

ifdef GS_NONETWORK
CFLAGS += -DGS_NONETWORK=1
SERVFILES += $(DEMO)
else
SERVFILES += $(NETFILES)
ALL += libnano-X.a
endif

all: $(ALL)

install: libnano-X.a nano-X
	cp libnano-X.a $(LIBDIR)
	chmod 644 $(LIBDIR)/libnano-X.a
	cp nano-X $(BINDIR)
	chmod 755 $(BINDIR)/nano-X
	cp nano-X.h $(INCDIR)

clean:
	rm -f *.o *.a nano-X core
	rm -f drivers/*.o
	rm -f ../examples/*.o
	(cd drivers/fonts; make clean)
	(cd drivers/bogl; make clean)

libnano-X.a: $(CLNTFILES)
	ar rcs libnano-X.a $(CLNTFILES)

drivers/bogl/libbogl.a:
	(cd drivers/bogl; make)

drivers/fonts/libfonts.a:
	(cd drivers/fonts; make)

nano-X: $(SERVFILES)
	$(CC) $(CFLAGS) $(SERVFILES) $(LIBS) -o nano-X

